Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/HeuristicLab.Algorithms.MemPR-3.3.csproj
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/HeuristicLab.Algorithms.MemPR-3.3.csproj	(revision 14449)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/HeuristicLab.Algorithms.MemPR-3.3.csproj	(revision 14450)
@@ -90,14 +90,25 @@
     <Compile Include="Binary\LocalSearch\ExhaustiveBitflipSubspace.cs" />
     <Compile Include="Binary\LocalSearch\ExhaustiveBitflip.cs" />
-    <Compile Include="Binary\LocalSearch\ExhaustiveBitflipOperator.cs" />
-    <Compile Include="Binary\LocalSearch\Heuristic.cs" />
-    <Compile Include="Binary\SolutionModel\Univariate\BiasedModelTrainerOperator.cs" />
-    <Compile Include="Binary\SolutionModel\Univariate\Trainer.cs" />
-    <Compile Include="Binary\SolutionModel\Univariate\UnbiasedModelTrainerOperator.cs" />
+    <Compile Include="Binary\LocalSearch\StaticAPI\ExhaustiveBitflip.cs" />
+    <Compile Include="Binary\SolutionModel\Univariate\StaticAPI\Trainer.cs" />
     <Compile Include="Binary\SolutionModel\Univariate\UnivariateSolutionModel.cs" />
     <Compile Include="Binary\SolutionModel\Univariate\BiasedModelTrainer.cs" />
     <Compile Include="Binary\SolutionModel\Univariate\UnbiasedModelTrainer.cs" />
-    <Compile Include="Optimization\Interfaces.cs" />
+    <Compile Include="Interfaces\Interfaces.cs" />
     <Compile Include="MemPRAlgorithm.cs" />
+    <Compile Include="Permutation\PermutationMemPR.cs" />
+    <Compile Include="Permutation\PermutationMemPRContext.cs" />
+    <Compile Include="Permutation\LocalSearch\ExhaustiveHillClimbSubspace.cs" />
+    <Compile Include="Permutation\LocalSearch\ExhaustiveHillClimb.cs" />
+    <Compile Include="Permutation\PermutationSolutionSubspace.cs" />
+    <Compile Include="Permutation\LocalSearch\StaticAPI\Exhaustive.cs" />
+    <Compile Include="Permutation\LocalSearch\StaticAPI\Exhaustive1Shift.cs" />
+    <Compile Include="Permutation\LocalSearch\StaticAPI\Exhaustive2Opt.cs" />
+    <Compile Include="Permutation\LocalSearch\StaticAPI\ExhaustiveSwap2.cs" />
+    <Compile Include="Permutation\SimilarityCalculator.cs" />
+    <Compile Include="Permutation\SolutionModel\Univariate\StaticAPI\Trainer.cs" />
+    <Compile Include="Permutation\SolutionModel\Univariate\UnbiasedModelTrainer.cs" />
+    <Compile Include="Permutation\SolutionModel\Univariate\UnivariateRelativeModel.cs" />
+    <Compile Include="Permutation\SolutionModel\Univariate\UnivariateAbsoluteModel.cs" />
     <Compile Include="SingleObjectiveSolutionScope.cs" />
     <Compile Include="MemPRContext.cs" />
@@ -105,4 +116,6 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Util\CkMeans1D.cs" />
+    <Compile Include="Util\EvaluationWrapper.cs" />
+    <Compile Include="Util\FitnessComparer.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -142,4 +155,9 @@
       <Private>False</Private>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.PermutationEncoding\3.3\HeuristicLab.Encodings.PermutationEncoding-3.3.csproj">
+      <Project>{dbecb8b0-b166-4133-baf1-ed67c3fd7fca}</Project>
+      <Name>HeuristicLab.Encodings.PermutationEncoding-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
       <Project>{23da7ff4-d5b8-41b6-aa96-f0561d24f3ee}</Project>
@@ -176,4 +194,5 @@
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Interfaces/Interfaces.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Interfaces/Interfaces.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Interfaces/Interfaces.cs	(revision 14450)
@@ -0,0 +1,111 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+ 
+using System.Collections.Generic;
+using HeuristicLab.Algorithms.MemPR.Binary;
+using HeuristicLab.Algorithms.MemPR.Permutation;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Algorithms.MemPR.Interfaces {
+
+  /*************************************************
+   * ********************************************* *
+   *                    DATA                       *
+   * ********************************************* *
+   *************************************************/
+
+  public interface ISolutionModel<TSolution> : IItem {
+    TSolution Sample();
+  }
+
+  public interface ISolutionSubspace<TSolution> : IItem { }
+
+  /*************************************************
+   * ********************************************* *
+   *                  OPERATORS                    *
+   * ********************************************* *
+   *************************************************/
+   
+  public interface ISolutionModelTrainer<TContext> : IItem {
+    void TrainModel(TContext context);
+  }
+
+  public interface ILocalSearch<TContext> : IItem {
+    void Optimize(TContext context);
+  }
+  
+  /*************************************************
+   * ********************************************* *
+   *                  CONTEXTS                     *
+   * ********************************************* *
+   *************************************************/
+
+  public interface IHeuristicAlgorithmContext<TProblem, TSolution> : IExecutionContext
+      where TProblem : class, ISingleObjectiveProblemDefinition {
+    TProblem Problem { get; }
+    IRandom Random { get; }
+    int Iterations { get; set; }
+    int EvaluatedSolutions { get; }
+    void IncrementEvaluatedSolutions(int byEvaluations);
+    double BestQuality { get; set; }
+    TSolution BestSolution { get; set; }
+  }
+
+  public interface IPopulationBasedHeuristicAlgorithmContext<TProblem, TSolution> : IHeuristicAlgorithmContext<TProblem, TSolution>
+      where TProblem : class, ISingleObjectiveProblemDefinition {
+    IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Population { get; }
+  }
+
+  public interface ISingleSolutionHeuristicAlgorithmContext<TProblem, TSolution> : IHeuristicAlgorithmContext<TProblem, TSolution>
+      where TProblem : class, ISingleObjectiveProblemDefinition {
+    ISingleObjectiveSolutionScope<TSolution> Solution { get; }
+  }
+
+  public interface ISolutionModelContext<TSolution> : IExecutionContext {
+    ISolutionModel<TSolution> Model { get; set; }
+  }
+
+  public interface ISolutionSubspaceContext<TSolution> : IExecutionContext {
+    ISolutionSubspace<TSolution> Subspace { get; }
+  }
+  public interface IBinaryVectorSubspaceContext : ISolutionSubspaceContext<BinaryVector> {
+    new BinarySolutionSubspace Subspace { get; }
+  }
+  public interface IPermutationSubspaceContext : ISolutionSubspaceContext<Encodings.PermutationEncoding.Permutation> {
+    new PermutationSolutionSubspace Subspace { get; }
+  }
+
+
+  /*************************************************
+   * ********************************************* *
+   *                   SCOPES                      *
+   * ********************************************* *
+   *************************************************/
+
+  public interface ISingleObjectiveSolutionScope<TSolution> : IScope {
+    TSolution Solution { get; set; }
+    double Fitness { get; set; }
+
+    void Adopt(ISingleObjectiveSolutionScope<TSolution> orphan);
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRAlgorithm.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRAlgorithm.cs	(revision 14449)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRAlgorithm.cs	(revision 14450)
@@ -26,4 +26,5 @@
 using System.Runtime.CompilerServices;
 using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
 using HeuristicLab.Algorithms.MemPR.Util;
 using HeuristicLab.Analysis;
@@ -32,6 +33,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
-using HeuristicLab.Optimization.LocalSearch;
-using HeuristicLab.Optimization.SolutionModel;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -40,24 +39,18 @@
   [Item("MemPR Algorithm", "Base class for MemPR algorithms")]
   [StorableClass]
-  public abstract class MemPRAlgorithm<TSolution, TContext, TSolutionContext> : BasicAlgorithm, INotifyPropertyChanged
+  public abstract class MemPRAlgorithm<TProblem, TSolution, TPopulationContext, TSolutionContext> : BasicAlgorithm, INotifyPropertyChanged
+      where TProblem : class, IItem, ISingleObjectiveHeuristicOptimizationProblem, ISingleObjectiveProblemDefinition
       where TSolution : class, IItem
-      where TContext : MemPRContext<TSolution, TContext, TSolutionContext>, new()
-      where TSolutionContext : SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> {
+      where TPopulationContext : MemPRPopulationContext<TProblem, TSolution, TPopulationContext, TSolutionContext>, new()
+      where TSolutionContext : MemPRSolutionContext<TProblem, TSolution, TPopulationContext, TSolutionContext> {
     private const double MutationProbabilityMagicConst = 0.1;
 
     public override Type ProblemType {
-      get { return typeof(ISingleObjectiveHeuristicOptimizationProblem); }
-    }
-
-    public new ISingleObjectiveHeuristicOptimizationProblem Problem {
-      get { return (ISingleObjectiveHeuristicOptimizationProblem)base.Problem; }
+      get { return typeof(TProblem); }
+    }
+
+    public new TProblem Problem {
+      get { return (TProblem)base.Problem; }
       set { base.Problem = value; }
-    }
-
-    protected bool Maximization {
-      get {
-        return Problem != null && Problem.MaximizationParameter is IValueParameter<BoolValue>
-          && ((IValueParameter<BoolValue>)Problem.MaximizationParameter).Value.Value;
-      }
     }
 
@@ -122,15 +115,15 @@
     }
 
-    public IConstrainedValueParameter<ISolutionModelTrainer<TSolution, TContext>> SolutionModelTrainerParameter {
-      get { return (IConstrainedValueParameter<ISolutionModelTrainer<TSolution, TContext>>)Parameters["SolutionModelTrainer"]; }
-    }
-
-    public IConstrainedValueParameter<ILocalSearch<TSolution, TSolutionContext>> LocalSearchParameter {
-      get { return (IConstrainedValueParameter<ILocalSearch<TSolution, TSolutionContext>>)Parameters["LocalSearch"]; }
+    public IConstrainedValueParameter<ISolutionModelTrainer<TPopulationContext>> SolutionModelTrainerParameter {
+      get { return (IConstrainedValueParameter<ISolutionModelTrainer<TPopulationContext>>)Parameters["SolutionModelTrainer"]; }
+    }
+
+    public IConstrainedValueParameter<ILocalSearch<TSolutionContext>> LocalSearchParameter {
+      get { return (IConstrainedValueParameter<ILocalSearch<TSolutionContext>>)Parameters["LocalSearch"]; }
     }
 
     [Storable]
-    private TContext context;
-    public TContext Context {
+    private TPopulationContext context;
+    public TPopulationContext Context {
       get { return context; }
       protected set {
@@ -146,5 +139,5 @@
     [StorableConstructor]
     protected MemPRAlgorithm(bool deserializing) : base(deserializing) { }
-    protected MemPRAlgorithm(MemPRAlgorithm<TSolution, TContext, TSolutionContext> original, Cloner cloner) : base(original, cloner) {
+    protected MemPRAlgorithm(MemPRAlgorithm<TProblem, TSolution, TPopulationContext, TSolutionContext> original, Cloner cloner) : base(original, cloner) {
       context = cloner.Clone(original.context);
       qualityAnalyzer = cloner.Clone(original.qualityAnalyzer);
@@ -159,6 +152,6 @@
       Parameters.Add(new FixedValueParameter<BoolValue>("SetSeedRandomly", "Whether each run of the algorithm should be conducted with a new random seed.", new BoolValue(true)));
       Parameters.Add(new FixedValueParameter<IntValue>("Seed", "The random number seed that is used in case SetSeedRandomly is false.", new IntValue(0)));
-      Parameters.Add(new ConstrainedValueParameter<ISolutionModelTrainer<TSolution, TContext>>("SolutionModelTrainer", "The object that creates a solution model that can be sampled."));
-      Parameters.Add(new ConstrainedValueParameter<ILocalSearch<TSolution, TSolutionContext>>("LocalSearch", "The local search operator to use."));
+      Parameters.Add(new ConstrainedValueParameter<ISolutionModelTrainer<TPopulationContext>>("SolutionModelTrainer", "The object that creates a solution model that can be sampled."));
+      Parameters.Add(new ConstrainedValueParameter<ILocalSearch<TSolutionContext>>("LocalSearch", "The local search operator to use."));
 
       qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
@@ -211,6 +204,6 @@
     }
 
-    protected virtual TContext CreateContext() {
-      return new TContext();
+    protected virtual TPopulationContext CreateContext() {
+      return new TPopulationContext();
     }
 
@@ -221,5 +214,5 @@
         Context.Random.Reset(Seed);
         Context.Scope.Variables.Add(new Variable("Results", Results));
-        Context.Maximization = Maximization;
+        Context.Problem = Problem;
       }
 
@@ -303,5 +296,5 @@
           }
         } else {
-          offspring = (SingleObjectiveSolutionScope<TSolution>)Context.AtPopulation(Context.Random.Next(Context.PopulationCount)).Clone();
+          offspring = (ISingleObjectiveSolutionScope<TSolution>)Context.AtPopulation(Context.Random.Next(Context.PopulationCount)).Clone();
           Mutate(offspring, token);
           PerformTabuWalk(offspring, Context.HcSteps, token);
@@ -458,6 +451,6 @@
     protected bool IsBetter(double a, double b) {
       return double.IsNaN(b) && !double.IsNaN(a)
-        || Maximization && a > b
-        || !Maximization && a < b;
+        || Problem.Maximization && a > b
+        || !Problem.Maximization && a < b;
     }
     
@@ -465,5 +458,5 @@
     protected abstract double Dist(ISingleObjectiveSolutionScope<TSolution> a, ISingleObjectiveSolutionScope<TSolution> b);
     protected abstract ISingleObjectiveSolutionScope<TSolution> ToScope(TSolution code, double fitness = double.NaN);
-    protected abstract ISolutionSubspace CalculateSubspace(IEnumerable<TSolution> solutions, bool inverse = false);
+    protected abstract ISolutionSubspace<TSolution> CalculateSubspace(IEnumerable<TSolution> solutions, bool inverse = false);
     protected virtual void Evaluate(ISingleObjectiveSolutionScope<TSolution> scope, CancellationToken token) {
       Context.EvaluatedSolutions++;
@@ -478,9 +471,13 @@
 
     #region Create
-    protected abstract ISingleObjectiveSolutionScope<TSolution> Create(CancellationToken token);
+    protected virtual ISingleObjectiveSolutionScope<TSolution> Create(CancellationToken token) {
+      var child = ToScope(null);
+      RunOperator(Problem.SolutionCreator, child, token);
+      return child;
+    }
     #endregion
 
     #region Improve
-    protected virtual int HillClimb(ISingleObjectiveSolutionScope<TSolution> scope, CancellationToken token, ISolutionSubspace subspace = null) {
+    protected virtual int HillClimb(ISingleObjectiveSolutionScope<TSolution> scope, CancellationToken token, ISolutionSubspace<TSolution> subspace = null) {
       if (double.IsNaN(scope.Fitness)) Evaluate(scope, token);
       var before = scope.Fitness;
@@ -492,5 +489,5 @@
     }
 
-    protected virtual void PerformTabuWalk(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace subspace = null) {
+    protected virtual void PerformTabuWalk(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace<TSolution> subspace = null) {
       if (double.IsNaN(scope.Fitness)) Evaluate(scope, token);
       var before = scope.Fitness;
@@ -501,6 +498,6 @@
         scope.Adopt(newScope);
     }
-    protected abstract void TabuWalk(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace subspace = null);
-    protected virtual void TabuClimb(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace subspace = null) {
+    protected abstract void TabuWalk(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace<TSolution> subspace = null);
+    protected virtual void TabuClimb(ISingleObjectiveSolutionScope<TSolution> scope, int steps, CancellationToken token, ISolutionSubspace<TSolution> subspace = null) {
       if (double.IsNaN(scope.Fitness)) Evaluate(scope, token);
       var before = scope.Fitness;
@@ -546,5 +543,5 @@
 
     protected abstract ISingleObjectiveSolutionScope<TSolution> Cross(ISingleObjectiveSolutionScope<TSolution> p1, ISingleObjectiveSolutionScope<TSolution> p2, CancellationToken token);
-    protected abstract void Mutate(ISingleObjectiveSolutionScope<TSolution> offspring, CancellationToken token, ISolutionSubspace subspace = null);
+    protected abstract void Mutate(ISingleObjectiveSolutionScope<TSolution> offspring, CancellationToken token, ISolutionSubspace<TSolution> subspace = null);
     #endregion
 
@@ -651,5 +648,5 @@
       var biasedStdev = Math.Sqrt(varEnd - (cov * cov) / varStart);
 
-      if (Maximization) {
+      if (Problem.Maximization) {
         var goal = Context.Population.Min(x => x.Fitness);
         var z = (goal - biasedMean) / biasedStdev;
@@ -665,6 +662,6 @@
       return MaximumEvaluations.HasValue && Context.EvaluatedSolutions >= MaximumEvaluations.Value
         || MaximumExecutionTime.HasValue && ExecutionTime >= MaximumExecutionTime.Value
-        || TargetQuality.HasValue && (Maximization && Context.BestQuality >= TargetQuality.Value
-                                  || !Maximization && Context.BestQuality <= TargetQuality.Value);
+        || TargetQuality.HasValue && (Problem.Maximization && Context.BestQuality >= TargetQuality.Value
+                                  || !Problem.Maximization && Context.BestQuality <= TargetQuality.Value);
     }
 
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14449)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14450)
@@ -23,9 +23,9 @@
 using System.Collections.Generic;
 using System.Linq;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
-using HeuristicLab.Optimization.SolutionModel;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -35,10 +35,10 @@
   [Item("MemPRContext", "Abstract base class for MemPR contexts.")]
   [StorableClass]
-  public abstract class MemPRContext<TSolution, TContext, TSolutionContext> : ParameterizedNamedItem,
-      ISingleObjectivePopulationContext<TSolution>, ISolutionModelContext<TSolution>, IStochasticContext,
-      IMaximizationContext, IEvaluatedSolutionsContext
+  public abstract class MemPRPopulationContext<TProblem, TSolution, TPopulationContext, TSolutionContext> : ParameterizedNamedItem,
+    IPopulationBasedHeuristicAlgorithmContext<TProblem, TSolution>, ISolutionModelContext<TSolution>
+      where TProblem : class, IItem, ISingleObjectiveProblemDefinition
       where TSolution : class, IItem
-      where TContext : MemPRContext<TSolution, TContext, TSolutionContext>
-      where TSolutionContext : SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> {
+      where TPopulationContext : MemPRPopulationContext<TProblem, TSolution, TPopulationContext, TSolutionContext>
+      where TSolutionContext : MemPRSolutionContext<TProblem, TSolution, TPopulationContext, TSolutionContext> {
 
     private IExecutionContext parent;
@@ -60,8 +60,8 @@
 
     [Storable]
-    private IValueParameter<BoolValue> maximization;
-    public bool Maximization {
-      get { return maximization.Value.Value; }
-      set { maximization.Value.Value = value; }
+    private IValueParameter<TProblem> problem;
+    public TProblem Problem {
+      get { return problem.Value; }
+      set { problem.Value = value; }
     }
 
@@ -95,4 +95,11 @@
 
     [Storable]
+    private IValueParameter<TSolution> bestSolution;
+    public TSolution BestSolution {
+      get { return bestSolution.Value; }
+      set { bestSolution.Value = value; }
+    }
+
+    [Storable]
     private IValueParameter<IntValue> hcSteps;
     public int HcSteps {
@@ -142,8 +149,4 @@
       set { random.Value = value; }
     }
-
-    IEnumerable<IScope> IPopulationContext.Population {
-      get { return scope.SubScopes; }
-    }
     
     public IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Population {
@@ -183,13 +186,14 @@
 
     [StorableConstructor]
-    protected MemPRContext(bool deserializing) : base(deserializing) { }
-    protected MemPRContext(MemPRContext<TSolution, TContext, TSolutionContext> original, Cloner cloner)
+    protected MemPRPopulationContext(bool deserializing) : base(deserializing) { }
+    protected MemPRPopulationContext(MemPRPopulationContext<TProblem, TSolution, TPopulationContext, TSolutionContext> original, Cloner cloner)
       : base(original, cloner) {
       scope = cloner.Clone(original.scope);
-      maximization = cloner.Clone(original.maximization);
+      problem = cloner.Clone(original.problem);
       initialized = cloner.Clone(original.initialized);
       iterations = cloner.Clone(original.iterations);
       evaluatedSolutions = cloner.Clone(original.evaluatedSolutions);
       bestQuality = cloner.Clone(original.bestQuality);
+      bestSolution = cloner.Clone(original.bestSolution);
       hcSteps = cloner.Clone(original.hcSteps);
       byBreeding = cloner.Clone(original.byBreeding);
@@ -205,13 +209,14 @@
       Model = cloner.Clone(original.Model);
     }
-    public MemPRContext() : this("MemPRContext") { }
-    public MemPRContext(string name) : base(name) {
+    public MemPRPopulationContext() : this("MemPRContext") { }
+    public MemPRPopulationContext(string name) : base(name) {
       scope = new Scope("Global");
 
-      Parameters.Add(maximization = new ValueParameter<BoolValue>("Maximization", new BoolValue(false)));
+      Parameters.Add(problem = new ValueParameter<TProblem>("Problem"));
       Parameters.Add(initialized = new ValueParameter<BoolValue>("Initialized", new BoolValue(false)));
       Parameters.Add(iterations = new ValueParameter<IntValue>("Iterations", new IntValue(0)));
       Parameters.Add(evaluatedSolutions = new ValueParameter<IntValue>("EvaluatedSolutions", new IntValue(0)));
       Parameters.Add(bestQuality = new ValueParameter<DoubleValue>("BestQuality", new DoubleValue(double.NaN)));
+      Parameters.Add(bestSolution = new ValueParameter<TSolution>("BestSolution"));
       Parameters.Add(hcSteps = new ValueParameter<IntValue>("HcSteps", new IntValue(0)));
       Parameters.Add(byBreeding = new ValueParameter<IntValue>("ByBreeding", new IntValue(0)));
@@ -229,4 +234,9 @@
     public abstract TSolutionContext CreateSingleSolutionContext(ISingleObjectiveSolutionScope<TSolution> solution);
 
+    public void IncrementEvaluatedSolutions(int byEvaluations) {
+      if (byEvaluations < 0) throw new ArgumentException("Can only increment and not decrement evaluated solutions.");
+      EvaluatedSolutions += byEvaluations;
+    }
+
     #region IExecutionContext members
     public IAtomicOperation CreateOperation(IOperator op) {
@@ -246,18 +256,14 @@
     }
     #endregion
-
-    IEnumerable<ISolutionScope<TSolution>> IPopulationContext<TSolution>.Population {
-      get { return Population; }
-    }
   }
 
   [Item("SingleSolutionMemPRContext", "Abstract base class for single solution MemPR contexts.")]
   [StorableClass]
-  public abstract class SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> : ParameterizedNamedItem,
-      ISingleObjectiveSolutionContext<TSolution>, IEvaluatedSolutionsContext,
-      IIterationsManipulationContext, IStochasticContext, IMaximizationContext
+  public abstract class MemPRSolutionContext<TProblem, TSolution, TContext, TSolutionContext> : ParameterizedNamedItem,
+    ISingleSolutionHeuristicAlgorithmContext<TProblem, TSolution>
+      where TProblem : class, IItem, ISingleObjectiveProblemDefinition
       where TSolution : class, IItem
-      where TContext : MemPRContext<TSolution, TContext, TSolutionContext>
-      where TSolutionContext : SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> {
+      where TContext : MemPRPopulationContext<TProblem, TSolution, TContext, TSolutionContext>
+      where TSolutionContext : MemPRSolutionContext<TProblem, TSolution, TContext, TSolutionContext> {
 
     private TContext parent;
@@ -276,7 +282,17 @@
       get { return Parameters; }
     }
-    
-    public bool Maximization {
-      get { return parent.Maximization; }
+
+    public TProblem Problem {
+      get { return parent.Problem; }
+    }
+
+    public double BestQuality {
+      get { return parent.BestQuality; }
+      set { parent.BestQuality = value; }
+    }
+
+    public TSolution BestSolution {
+      get { return parent.BestSolution; }
+      set { parent.BestSolution = value; }
     }
 
@@ -299,19 +315,11 @@
     }
 
-    IScope ISolutionContext.Solution {
+    ISingleObjectiveSolutionScope<TSolution> ISingleSolutionHeuristicAlgorithmContext<TProblem, TSolution>.Solution {
       get { return scope; }
     }
 
-    ISolutionScope<TSolution> ISolutionContext<TSolution>.Solution {
-      get { return scope; }
-    }
-
-    ISingleObjectiveSolutionScope<TSolution> ISingleObjectiveSolutionContext<TSolution>.Solution {
-      get { return scope; }
-    }
-
     [StorableConstructor]
-    protected SingleSolutionMemPRContext(bool deserializing) : base(deserializing) { }
-    protected SingleSolutionMemPRContext(SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> original, Cloner cloner)
+    protected MemPRSolutionContext(bool deserializing) : base(deserializing) { }
+    protected MemPRSolutionContext(MemPRSolutionContext<TProblem, TSolution, TContext, TSolutionContext> original, Cloner cloner)
       : base(original, cloner) {
       scope = cloner.Clone(original.scope);
@@ -319,5 +327,5 @@
       iterations = cloner.Clone(original.iterations);
     }
-    public SingleSolutionMemPRContext(TContext baseContext, ISingleObjectiveSolutionScope<TSolution> solution) {
+    public MemPRSolutionContext(TContext baseContext, ISingleObjectiveSolutionScope<TSolution> solution) {
       parent = baseContext;
       scope = solution;
@@ -327,4 +335,9 @@
     }
 
+    public void IncrementEvaluatedSolutions(int byEvaluations) {
+      if (byEvaluations < 0) throw new ArgumentException("Can only increment and not decrement evaluated solutions.");
+      EvaluatedSolutions += byEvaluations;
+    }
+
     #region IExecutionContext members
     public IAtomicOperation CreateOperation(IOperator op) {
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimb.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimb.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/LocalSearch/ExhaustiveHillClimb.cs	(revision 14450)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Threading;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Algorithms.MemPR.Util;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.LocalSearch {
+  [Item("Exhaustive Hillclimber (permutation)", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public class ExhaustiveHillClimb<TContext> : NamedItem, ILocalSearch<TContext>
+      where TContext : ISingleSolutionHeuristicAlgorithmContext<SingleObjectiveBasicProblem<PermutationEncoding>, Encodings.PermutationEncoding.Permutation> {
+
+    [StorableConstructor]
+    protected ExhaustiveHillClimb(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveHillClimb(ExhaustiveHillClimb<TContext> original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveHillClimb() {
+      Name = ItemName;
+      Description = ItemDescription;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveHillClimb<TContext>(this, cloner);
+    }
+
+    public void Optimize(TContext context) {
+      var evalWrapper = new EvaluationWrapper<Encodings.PermutationEncoding.Permutation>(context.Problem, context.Solution);
+      var quality = context.Solution.Fitness;
+      try {
+        var result = Exhaustive.HillClimb(context.Random, context.Solution.Solution, ref quality,
+          context.Problem.Maximization, evalWrapper.Evaluate, CancellationToken.None);
+        context.IncrementEvaluatedSolutions(result.Item1);
+        context.Iterations = result.Item2;
+      } finally {
+        context.Solution.Fitness = quality;
+      }
+    }
+  }
+}
